/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-19 16:59:56 UTC)
 * on 2013-06-19 at 23:00:36 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.prediction.model;

/**
 * Model definition for Output.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Prediction API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Output extends com.google.api.client.json.GenericJson {

  /**
   * The unique name for the predictive model.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * What kind of resource this is.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The most likely class label (Categorical models only).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String outputLabel;

  /**
   * A list of class labels with their estimated probabilities (Categorical models only).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<OutputMulti> outputMulti;

  static {
    // hack to force ProGuard to consider OutputMulti used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(OutputMulti.class);
  }

  /**
   * The estimated regression value (Regression models only).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String outputValue;

  /**
   * A URL to re-request this resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String selfLink;

  /**
   * The unique name for the predictive model.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The unique name for the predictive model.
   * @param id id or {@code null} for none
   */
  public Output setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * What kind of resource this is.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * What kind of resource this is.
   * @param kind kind or {@code null} for none
   */
  public Output setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The most likely class label (Categorical models only).
   * @return value or {@code null} for none
   */
  public java.lang.String getOutputLabel() {
    return outputLabel;
  }

  /**
   * The most likely class label (Categorical models only).
   * @param outputLabel outputLabel or {@code null} for none
   */
  public Output setOutputLabel(java.lang.String outputLabel) {
    this.outputLabel = outputLabel;
    return this;
  }

  /**
   * A list of class labels with their estimated probabilities (Categorical models only).
   * @return value or {@code null} for none
   */
  public java.util.List<OutputMulti> getOutputMulti() {
    return outputMulti;
  }

  /**
   * A list of class labels with their estimated probabilities (Categorical models only).
   * @param outputMulti outputMulti or {@code null} for none
   */
  public Output setOutputMulti(java.util.List<OutputMulti> outputMulti) {
    this.outputMulti = outputMulti;
    return this;
  }

  /**
   * The estimated regression value (Regression models only).
   * @return value or {@code null} for none
   */
  public java.lang.String getOutputValue() {
    return outputValue;
  }

  /**
   * The estimated regression value (Regression models only).
   * @param outputValue outputValue or {@code null} for none
   */
  public Output setOutputValue(java.lang.String outputValue) {
    this.outputValue = outputValue;
    return this;
  }

  /**
   * A URL to re-request this resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getSelfLink() {
    return selfLink;
  }

  /**
   * A URL to re-request this resource.
   * @param selfLink selfLink or {@code null} for none
   */
  public Output setSelfLink(java.lang.String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  @Override
  public Output set(String fieldName, Object value) {
    return (Output) super.set(fieldName, value);
  }

  @Override
  public Output clone() {
    return (Output) super.clone();
  }

  /**
   * Model definition for OutputOutputMulti.
   */
  public static final class OutputMulti extends com.google.api.client.json.GenericJson {

    /**
     * The class label.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String label;

    /**
     * The probability of the class label.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String score;

    /**
     * The class label.
     * @return value or {@code null} for none
     */
    public java.lang.String getLabel() {
      return label;
    }

    /**
     * The class label.
     * @param label label or {@code null} for none
     */
    public OutputMulti setLabel(java.lang.String label) {
      this.label = label;
      return this;
    }

    /**
     * The probability of the class label.
     * @return value or {@code null} for none
     */
    public java.lang.String getScore() {
      return score;
    }

    /**
     * The probability of the class label.
     * @param score score or {@code null} for none
     */
    public OutputMulti setScore(java.lang.String score) {
      this.score = score;
      return this;
    }

    @Override
    public OutputMulti set(String fieldName, Object value) {
      return (OutputMulti) super.set(fieldName, value);
    }

    @Override
    public OutputMulti clone() {
      return (OutputMulti) super.clone();
    }

  }

}
